unit Unit1;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, SampleDisplay_TLB, Vcl.ComCtrls, Vcl.ExtCtrls, PNGImage;

type
  TForm1 = class(TForm, IProgress)
    GroupBox1: TGroupBox;
    Button3: TButton;
    Label1: TLabel;
    EditInputFileName: TEdit;
    Button4: TButton;
    EditOutputFileName: TEdit;
    Label2: TLabel;
    Button5: TButton;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    ProgressBar1: TProgressBar;
    Button6: TButton;
    Image1: TImage;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    Label4: TLabel;
    ComboBox1: TComboBox;
    Button1: TButton;
    procedure Button3Click(Sender: TObject);
    procedure Button5Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    function ProgressCallback(Progress: Double): HResult; stdcall;
  public
    { Public declarations }
  end;

  function SampleDisplay_CreatePicture(SourceFileName, OutputFileName: PChar; Width, Height: Integer; TopColor, BottomColor, BackgroundColor, CaptionColor: Cardinal; Caption: PChar; AALevel: Integer; Quantize: Integer; Progress: IProgress): HResult; stdcall; external 'SampleDisplay.dll';
  function SampleDisplay_CreatePictureHandle(SourceFileName: PChar; Width, Height: Integer; TopColor, BottomColor, BackgroundColor, CaptionColor: Cardinal; Caption: PChar; AALevel: Integer; var BitmapHandle: THandle; Progress: IProgress): HResult; stdcall; external 'SampleDisplay.dll';

var
  Form1: TForm1;

implementation

{$R *.dfm}

Uses
    ComObj;

procedure TForm1.Button6Click(Sender: TObject);
var
    SampleDisplay: ISampleDisplay;
    Error: HResult;
    TopColor, BottomColor, BackgroundColor, CaptionColor: Cardinal;
begin
    //* Color presets
    case ComboBox1.ItemIndex of
        //* Black theme
        0: begin
            TopColor := $FFFFFF00;
            BottomColor := $FF00FF00;
            BackgroundColor := $FF000000;
            CaptionColor := $FF888888;
        end;
        //* Transparent blue theme
        1: begin
            TopColor := $FF9999FF;
            BottomColor := $FF0000FF;
            BackgroundColor := $00FFFFFF;
            CaptionColor := $FF888888;
        end;
        //* Orange theme
        2: begin
            TopColor := $FFFFFF00;
            BottomColor := $FFFF8000;
            BackgroundColor := $00FFFFFF;
            CaptionColor := $FF888888;
        end;
    else begin
            TopColor := $FFFFFF00;
            BottomColor := $FF00FF00;
            BackgroundColor := $FF000000;
            CaptionColor := $FF888888;
        end;
    end;
    //* Direct DLL call
    if RadioButton1.Checked then begin
        Error := SampleDisplay_CreatePicture(PChar(EditInputFileName.Text), PChar(EditOutputFileName.Text), Image1.Width, Image1.Height, TopColor, BottomColor, BackgroundColor, CaptionColor, PChar('My caption here'), 4, 0, Self);
        Image1.Picture.LoadFromFile(EditOutputFileName.Text);
        if Error <> 0 then begin
            Showmessage('Error: ' + IntToStr(Error));
        end;
    end;
    //* COM class
    if RadioButton2.Checked then begin
        //* Acquire the class
        SampleDisplay := CreateComObject(CLASS_CreateDisplay) as ISampleDisplay;
        //* Generate sample picture: top color yellow, bottom color lime, background black, cpation color gray, antialiasing level 4, no quantize to 8 bit but 32 bit
        Error := SampleDisplay.CreatePicture(EditInputFileName.Text, EditOutputFileName.Text, Image1.Width, Image1.Height, TopColor, BottomColor, BackgroundColor, CaptionColor, 'My caption here', 4, 0, Self);
        Image1.Picture.LoadFromFile(EditOutputFileName.Text);
        if Error <> 0 then begin
            Showmessage('Error: ' + IntToStr(Error));
        end;
    end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
    SampleDisplay: ISampleDisplay;
    Error: HResult;
    TopColor, BottomColor, BackgroundColor, CaptionColor: Cardinal;
    BitmapHandle: THandle;
    BitmapHandleVariant: OleVariant;
begin
    //* Color presets
    case ComboBox1.ItemIndex of
        //* Black theme
        0: begin
            TopColor := $FFFFFF00;
            BottomColor := $FF00FF00;
            BackgroundColor := $FF000000;
            CaptionColor := $FF888888;
        end;
        //* Transparent blue theme
        1: begin
            TopColor := $FF9999FF;
            BottomColor := $FF0000FF;
            BackgroundColor := $00FFFFFF;
            CaptionColor := $FF888888;
        end;
        //* Orange theme
        2: begin
            TopColor := $FFFFFF00;
            BottomColor := $FFFF8000;
            BackgroundColor := $00FFFFFF;
            CaptionColor := $FF888888;
        end;
    else begin
            TopColor := $FFFFFF00;
            BottomColor := $FF00FF00;
            BackgroundColor := $FF000000;
            CaptionColor := $FF888888;
        end;
    end;
    //* Direct DLL call
    if RadioButton1.Checked then begin
        Error := SampleDisplay_CreatePictureHandle(PChar(EditInputFileName.Text), Image1.Width, Image1.Height, TopColor, BottomColor, BackgroundColor, CaptionColor, PChar('My caption here'), 4, BitmapHandle, Self);
        Image1.Picture.Bitmap.Handle := BitmapHandle;
        Image1.Picture.Bitmap.Dormant; //* Don't know why this is needed, the picture does not appear else.
        if Error <> 0 then begin
            Showmessage('Error: ' + IntToStr(Error));
        end;
    end;
    //* COM class
    if RadioButton2.Checked then begin
        //* Acquire the class
        SampleDisplay := CreateComObject(CLASS_CreateDisplay) as ISampleDisplay;
        //* Generate sample picture: top color yellow, bottom color lime, background black, cpation color gray, antialiasing level 4, no quantize to 8 bit but 32 bit
        Error := SampleDisplay.CreatePictureHandle(EditInputFileName.Text, Image1.Width, Image1.Height, TopColor, BottomColor, BackgroundColor, CaptionColor, 'My caption here', 4, BitmapHandleVariant, Self);
        Image1.Picture.Bitmap.Handle := BitmapHandleVariant;
        Image1.Picture.Bitmap.Dormant; //* Don't know why this is needed, the picture does not appear else.
        if Error <> 0 then begin
            Showmessage('Error: ' + IntToStr(Error));
        end;
    end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
    Close;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
    OpenDialog1.FileName := EditInputFileName.Text;
    if OpenDialog1.Execute then begin
        EditInputFileName.Text := OpenDialog1.FileName;
    end;
end;

procedure TForm1.Button5Click(Sender: TObject);
begin
    SaveDialog1.FileName := EditOutputFileName.Text;
    if SaveDialog1.Execute then begin
        EditOutputFileName.Text := SaveDialog1.FileName;
    end;
end;

function TForm1.ProgressCallback(Progress: Double): HResult; stdcall;
begin
    ProgressBar1.Position := Round(Progress);
    Result := S_OK;
end;

end.
